
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/exec.h>

int main (void)

{
struct Window *win;
struct RastPort *rp;
struct MsgPort *port;
struct IntuiMessage *mess;
BOOL cont;
BOOL left,right,up,down;
long x,y;
long vx,vy;
long w,h;

if (win = OpenWindowTags (NULL,
		WA_Title,"KeyJoy",
		WA_Left,80,WA_Top,40,
		WA_Width,400,WA_Height,300,
		WA_Flags,WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_GIMMEZEROZERO|WFLG_ACTIVATE,
		WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_RAWKEY|IDCMP_INTUITICKS,
		TAG_END))
	{
	rp = win->RPort;
	w = win->GZZWidth - 5;
	h = win->GZZHeight - 5;
	x = w / 2;
	y = h / 2;
	vx = 0;
	vy = 0;
	left = FALSE;
	right = FALSE;
	up = FALSE;
	down = FALSE;
	SetAPen (rp,2);
	RectFill (rp,x,y,x+3,y+3);
	port = win->UserPort;
	cont = TRUE;
	while (cont)
		{
		WaitPort (port);
		while (mess = (struct IntuiMessage *) GetMsg (port))
			{
			switch (mess->Class)
				{
			case IDCMP_INTUITICKS:
				if (left)  vx --;
				if (right) vx ++;
				if (up)    vy --;
				if (down)  vy ++;
				SetAPen (rp,1);
				RectFill (rp,x,y,x+3,y+3);
				x += vx;
				if (x <= 0 || x >= w)
					vx = -vx;
				y += vy;
				if (y <= 0 || y >= h)
					vy = -vy;
				SetAPen (rp,2);
				RectFill (rp,x,y,x+3,y+3);
				break;
			case IDCMP_CLOSEWINDOW:
				cont = FALSE;
				break;
			case IDCMP_RAWKEY:
				if (!(mess->Qualifier & IEQUALIFIER_REPEAT))
					{
					switch (mess->Code & ~IECODE_UP_PREFIX)
						{
					case 0x45: /* Esc */
						cont = FALSE;
						break;
					case 0x4f: /* Cursor left */
					case 0x2d: /* Numpad 4 */
						left = mess->Code & IECODE_UP_PREFIX ? FALSE : TRUE;
						break;
					case 0x4e: /* Cursor right */
					case 0x2f: /* Numpad 6 */
						right = mess->Code & IECODE_UP_PREFIX ? FALSE : TRUE;
						break;
					case 0x4c: /* Cursor up */
					case 0x3e: /* Numpad 8 */
						up = mess->Code & IECODE_UP_PREFIX ? FALSE : TRUE;
						break;
					case 0x4d: /* Cursor down */
					case 0x1e: /* Numpad 2 */
						down = mess->Code & IECODE_UP_PREFIX ? FALSE : TRUE;
						break;
						}
					}
				}
			ReplyMsg ((struct Message *) mess);
			}
		}
	
	CloseWindow (win);
	}

return (0);
}

